package com.javaseleniumtemplate.flows;

import com.javaseleniumtemplate.pages.CadastroServicoPage;

public class CadastroServicoFlows {
    CadastroServicoPage cadastroservico;

    public CadastroServicoFlows(){
        cadastroservico = new CadastroServicoPage();
    }

    public void navegarPaginaServico(String unidade){
        cadastroservico.ClicarMenu();
        cadastroservico.realizarFiltro(unidade);

    }

    public void cadastraServico(String nomeReduzido, String nomeFantasia, String tipoServico ,String horaPreparo){cadastroservico.insereInformacoes(nomeReduzido,nomeFantasia,tipoServico,horaPreparo);}

    public void marcaParametros(String tipoServico){
        cadastroservico.marcaParametrosServico(tipoServico);
    }

    public void configurarCardapio(){ cadastroservico.configuraCardapio();}

    public String retornaConfiguracaoPratoArroz(){return cadastroservico.configuracaoCardArroz();}

    public String retornaConfiguracaoPratoGuarnicao(){return cadastroservico.configuracaoCardGuarnicao();}

    public String retornaConfiguracaoPratoSalada(){return cadastroservico.configuracaoCardSalada();}

    public void exportarConfiguracaoCardapio(String CDUNIDADEDEST, String CDSERVFILIDEST){cadastroservico.exportarConfiguracaoCardapio(CDUNIDADEDEST,CDSERVFILIDEST);}

    public void editarConfigPadrao(){cadastroservico.editarConfiguracaoCard();}

    public void excluirConfiguracaoCard(){cadastroservico.excluirConfiguracaoServico();}

    public void cadastrCustoPadrao(String valorCusto){cadastroservico.custoPadrao(valorCusto);}

    public void manutencaoCustoPadrao(){cadastroservico.manutencaoCustoPadrao();}

    public void cadastrarTurno(String NMTURNO1, String QTDSEG, String QTDTER, String QTDQUAR, String QTDQUIN, String QTDSEXT,
                               String NMTURNO2, String QTDSEG2, String QTDTER2, String QTDQUAR2, String QTDQUIN2, String QTDSEXT2){
        cadastroservico.cadastraTurno(NMTURNO1,QTDSEG,QTDTER,QTDQUAR,QTDQUIN,QTDSEXT,NMTURNO2,QTDSEG2,QTDTER2,QTDQUAR2,QTDQUIN2,QTDSEXT2);
    }

    public String validaCadastroTunoManha(){return cadastroservico.validaCadastroTurnoManha();}

    public String validaCadastroTunoTarde(){return cadastroservico.validaCadastroTurnoTarde();}


    public void alterarComensaisTurno(String QTDSEG, String QTDTER, String QTDQUAR, String QTDQUIN, String QTDSEXT,
                                      String QTDSEG2, String QTDTER2, String QTDQUAR2, String QTDQUIN2, String QTDSEXT2){

        cadastroservico.alteraComensaisTurno(QTDSEG,QTDTER,QTDQUAR,QTDQUIN,QTDSEXT,QTDSEG2,QTDTER2,QTDQUAR2,QTDQUIN2,QTDSEXT2);

    }

    public String validaNomeAlteradoTurno1(){return cadastroservico.validaCadastroTurnoManha();}

    public String validaNomeAlteradoTurno2(){return cadastroservico.validaCadastroTurnoTarde();}

    public void excluindoTurno(){
        cadastroservico.excluirTurno();
    }

    public String validarExclusaoTurno(){
        return cadastroservico.validaExclusaoTurno();
    }

    public String validarExclusaoProdServFat(){
        return cadastroservico.validaExclusaoTurno();
    }

    public void insereComensaisServico(String QTSEG, String QTTER, String QTQUA, String QTQUIN, String QTSEX){cadastroservico.informaComensais(QTSEG,QTTER,QTQUA,QTQUIN,QTSEX);}

    public void informaPontoEntrega(String NMCLIENTE){cadastroservico.cadastroPontoEntrega(NMCLIENTE);}

    public String validaCadastroPontoEntrega(){return cadastroservico.msgEncontrada();}

    public void insereComensalPontoEntrega(String QTDCOESTCSSEG, String QTDCOMESTITER, String QTDCOMESTIQUA, String QTDCOESTCSQUI, String QTDCOMESTISEX){cadastroservico.comensaisPontoEntrega(QTDCOESTCSSEG,QTDCOMESTITER,QTDCOMESTIQUA,QTDCOESTCSQUI,QTDCOMESTISEX);
    }

    public void apagaPontoEntrega(){cadastroservico.apagaPontoEntrega();}

    public String validaExclusaoPontoEntrega(){return cadastroservico.validaExclusao();}

    public void abaFaturamento(String NOMESERVICO,String NMPRODUTOFATU, String VALPERCENTUAL)
    {
        cadastroservico.abaFaturamento(NOMESERVICO,NMPRODUTOFATU, VALPERCENTUAL);
    }

    public void adicionaInformacaoAplicativo(){cadastroservico.adicionaInformacaoAplicativos();}

    public void editarExcluirInfoAplicativos(String tipoAcao){cadastroservico.editarExcluirInformacaoAplicativos(tipoAcao);}

    public void abaEmbalagens(String TIPOEXPORTACAO,String NMPONTOENTREGA, String NMEMBALAGEM){
        cadastroservico.abaEmbalagens(TIPOEXPORTACAO,NMPONTOENTREGA,NMEMBALAGEM );
    }

    public void exportaComensais(String DTINICIAL, String DTFINAL){
        cadastroservico.exportaComensais(DTINICIAL, DTFINAL);
    }

    public void alteraComensaisPontoEntrega(String QTSEG, String QTTER, String QTQUAR,
                                            String QTQUIN, String QTSEX){
        cadastroservico.alteraComensaisCliente(QTSEG, QTTER, QTQUAR,QTQUIN,QTSEX);
    }

    public void exportaEmbalagem(String CDFILIAL){
        cadastroservico.exportarEmbalagem(CDFILIAL);
    }

    public void exportaEmbalagemPontoEntrega(String TIPOEXPORTACAO, String NMPONTOENTREGA,String CDFILIAL,String NMPONTOENTREGADEST){
        cadastroservico.exportarEmbalagem(TIPOEXPORTACAO,NMPONTOENTREGA,CDFILIAL, NMPONTOENTREGADEST);
    }

    public void importaEmbalagem(String CDUNIDADE,String TIPOIMPORTACAO){
        cadastroservico.importaEmbalagem(CDUNIDADE, TIPOIMPORTACAO);

    }

    public void excluirEmbalagemPontoEntrega(String TIPOEXCLUSAO, String NMPONTOENREGA){
        cadastroservico.excluirEmbalagemPontoEntrega(TIPOEXCLUSAO,NMPONTOENREGA);
    }

    public void alteraProdutoFaturamento(String CDPRODFATU){cadastroservico.alterarProdutoFaturamento(CDPRODFATU);}

    public void apagaServicoProdutoFaturamento(){cadastroservico.apagandoProdutoServicoFaturamento();}

    public String validaProdutoAlterado(){return cadastroservico.validaAlteracaoProdutoFaturamento();}



   



}
