package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

public class OpcoesProdutosReceitaPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaOpcoesProdutosReceita = By.xpath("//span[text() = 'Opções de Produtos na Receita']");

    By campoProcurar = By.xpath("//li[@class=\"float-action expandable fix-position-bottom opened\"]//input[@placeholder=\"Procurar\"]");
    By produtoCarbonatoBario500 = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CARBONATO DE BARIO 500G']");
    By produtoOleoGirassol = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'OLEO DE GIRASSOL']");
    By produtoTartarato = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'TARTARATO DE POTASSIO E ANTIMONIO']");
    By produtoSulfatoSodioGridAddProd = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'SULFATO DE SODIO']");
    By produtoSennaFolhasGridAddProd = By.xpath("//div[@id=\"grid-9000\"]//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'SENNA (FOLHAS)']");

    By botaoAdicionar = By.xpath("//div[@class=\"zh-footer-center\"]//li[@class=\"zh-ripple-effect\"]");
    By botaoCampoProduto = By.xpath("//div[@data-zh-id=\"193032326032462549791356\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoProdutoOpcional = By.xpath("//div[@id=\"NMPRODOPC\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoSalvar = By.xpath("//div[@class=\"zh-footer-right\"]");
    By botaoExcluirSelecionados = By.xpath("//div[@class=\"zh-footer-center\"]//span[@class=\"action-icon has-label\"]");
    By botaoSimMensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//footer[@class=\"zh-footer-alert\"]/button[1]");
    By botaoOk = By.xpath("//section[@class=\"zh-container-alert\"]//button[@data-ng-repeat=\"button in buttons\"]");
    By botaoCancelar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoVoltar = By.xpath("//div[@class=\"zh-footer-left\"]");
    By botaoExcluir = By.xpath("//div[@class=\"zh-footer-center\"]//div[@class=\"zh-test-box\"]");
    By botaoAbrirOpcoesControleTelaInicial = By.xpath("//div[@data-ng-if=\"widget.isFloatingControlVisible()\"]//div[@data-zh-floating-control]");
    By botaoPesquisarFiltro = By.xpath("//div[@class=\"control-menu\"]//li[@data-zh-id=\"zh-floating-control-custom-action-1\"]");

    By abaProdutoPrincipalReceita = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produto Principal da Receita']");
    By abaProdutosOpcionais = By.xpath("//div[@class=\"zh-tab-scroller\"]//a[text() = 'Produtos Opcionais']");
    By codigoProdutoPrincipalAbaProdPrinc = By.xpath("//div[@data-zh-id=\"193032326017965047551355\"]/p");
    By nomeProdutoPrincipalAbaProdPrinc = By.xpath("//div[@data-zh-id=\"193032326032462549791356\"]/p");

    By codigoProdutoOpcionalLinha1 = By.xpath("//div[@id=\"grid-193032326015092133471329\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVOPC\"]/span");
    By nomeProdutoOpcionalLinha1 = By.xpath("//div[@id=\"grid-193032326015092133471329\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODOPC\"]/span");

    By checkBoxProdutoOpcionalLinha2 = By.xpath("//div[@id=\"grid-193032326015092133471329\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By codigoProdutoOpcionalLinha2 = By.xpath("//div[@id=\"grid-193032326015092133471329\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"CDARVOPC\"]/span");
    By nomeProdutoOpcionalLinha2 = By.xpath("//div[@id=\"grid-193032326015092133471329\"]//div[@class=\"body-content\"]/div[2]//div[@data-zh-field-name=\"NMPRODOPC\"]/span");

    By checkBoxProdTelaInicialLinha1 = By.xpath("//div[@id=\"grid-193032326036450896671328\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"__CHECKBOX\"]/span");
    By codigoProdTelaInicialLinha1 = By.xpath("//div[@id=\"grid-193032326036450896671328\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"CDARVPROD\"]/span");
    By nomeProdTelaInicialLinha1 = By.xpath("//div[@id=\"grid-193032326036450896671328\"]//div[@class=\"body-content\"]/div[1]//div[@data-zh-field-name=\"NMPRODUTO\"]/span");

    By mensagemCantoSuperiorDireito = By.xpath("//*[@class=\"zh-notification-messages\"]//span[@class=\"notification-message-text\"]");
    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//p[@class=\"zh-text-alert\"]");
    By mensagemObrigatorioProdPrinc = By.xpath("//div[@data-zh-id=\"193032326032462549791356\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProdOpcional = By.xpath("//div[@data-zh-id=\"193032326027929424611336\"]//div[@class=\"zh-validation\"]/span");
    By mensagemNenhumRegistroEncontradoGridProdTelaIni = By.xpath("//div[@id=\"grid-193032326036450896671328\"]//div[@class=\"body-content\"]//p[@class=\"text-center zh-text-search-not-found ng-binding\"]");

    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Opções de Produtos na Receita");
        click(telaOpcoesProdutosReceita);
    }

    public void adicionarProdutoPrincipal() {
        tempo();
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "OLEO DE GIRASSOL");
        click(produtoOleoGirassol);
        click(botaoSalvar);

        //valores esperados para o produto adicionado
        String expCodigo = "0.22.5.0.00.000";
        String expNome = "OLEO DE GIRASSOL";

        //valores encontrados na aba produtos opcionais
        String encCodigo = getText(codigoProdutoOpcionalLinha1);
        String encNome = getText(nomeProdutoOpcionalLinha1);
        Assert.assertEquals(encCodigo, expCodigo, "Verificar código do primeiro produto opcional, após adicionar um produto principal");
        Assert.assertEquals(encNome, expNome, "Verificar nome do primeiro produto opcional, após adicionar um produto principal");

        click(abaProdutoPrincipalReceita);
        //valores encontratos da aba produto principal da receita
        encCodigo = getText(codigoProdutoPrincipalAbaProdPrinc);
        encNome = getText(nomeProdutoPrincipalAbaProdPrinc);
        Assert.assertEquals(encCodigo, expCodigo, "Verificar código do produto adiconado, na aba 'produto principal da receita'");
        Assert.assertEquals(encNome, expNome, "Verificar nome do produto adiconado, na aba 'produto principal da receita'");
        click(botaoVoltar);

        preencherCampoProcurarTelaInicial("0225000000");
        //valores encontrados na lista inicial de produtos da tela
        encCodigo = getText(codigoProdTelaInicialLinha1);
        encNome = getText(nomeProdTelaInicialLinha1);
        Assert.assertEquals(encCodigo, expCodigo, "Verificar código do produto adicionado, na tela inicial");
        Assert.assertEquals(encNome, expNome, "Verificar nome do produto adicionado, na tela inicial");
    }

    public void excluirProdutoPrincipal() {
        click(checkBoxProdTelaInicialLinha1);
        click(botaoExcluirSelecionados);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir um produto principal");
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida no canto superior direito da tela após excluir um produto principal");

        mensagem = getText(mensagemNenhumRegistroEncontradoGridProdTelaIni);
        mensagemEsperada = "Nenhum registro foi encontrado";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de nenhum registro encontrado, exibida no grid da lista de produtos após a exclusão do produto");
    }

    public void adicionarProdutoOpcional() {
        preencherCampoProcurarTelaInicial("101110200700");
        click(codigoProdTelaInicialLinha1);
        click(abaProdutosOpcionais);
        click(botaoAdicionar);
        click(botaoCampoProdutoOpcional);
        sendKeys(campoProcurar, "TARTARATO DE POTASSIO E ANTIMONIO");
        click(produtoTartarato);
        click(botaoSalvar);

        String mensagem = getText(mensagemCantoSuperiorDireito);
        String mensagemEsperada = "Salvo com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem no canto superior direito da tela após adicionar um produto opcional");

        //valores encontrados do produto opcional adicionado
        String encCodigo = getText(codigoProdutoOpcionalLinha2);
        String encNome = getText(nomeProdutoOpcionalLinha2);

        //valores esperados para o produto opcional adicionado
        String expCodigo = "1.01.1.1.02.023.00";
        String expNome = "TARTARATO DE POTASSIO E ANTIMONIO";
        Assert.assertEquals(encCodigo, expCodigo, "Verificar código do produto opcional adicionado");
        Assert.assertEquals(encNome, expNome, "Verificar nome do produto opcional adicionado");
    }

    public void excluirProdutoOpcional() {
        click(checkBoxProdutoOpcionalLinha2);
        click(botaoExcluirSelecionados);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Deletar o(s) registro(s)?";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir o produto opcional");
        tempo();
        click(botaoSimMensagemAlerta);

        mensagem = getText(mensagemCantoSuperiorDireito);
        mensagemEsperada = "Excluído com sucesso.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem de excluído com sucesso exbida no canto superior direito da tela");

        boolean existSegundoProdOpcional = returnIfElementExists(codigoProdutoOpcionalLinha2);
        Assert.assertEquals(existSegundoProdOpcional, false, "Verificar se após a exclusão do produto opcional. O produto principal passa há não possuir mais um segundo produto opcional");
    }

    public void tentarAdicionarProdutoDeCompras() {
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "CARBONATO DE BARIO 500G");
        click(produtoCarbonatoBario500);
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperado = "Tabela não pode conter produto de compra.";
        Assert.assertEquals(mensagem, mensagemEsperado, "Verificar mensagem exibida na tela após tentar adicionar um produto de compras");
        click(botaoOk);
        tempo();
        click(botaoCancelar);
    }

    public void tentarAdicionarProdutoPrincipalJaExistente() {
        click(botaoAdicionar);
        click(botaoCampoProduto);
        sendKeys(campoProcurar, "101160200200");
        click(produtoSulfatoSodioGridAddProd);
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Impossível adicionar. Registro já existe.";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após tentar adicionar um produto principal que já existe");
        click(botaoOk);
        tempo();
        click(botaoCancelar);
    }

    public void tentarExcluirProdutoEquivalenteIgualPrincipal() {
        preencherCampoProcurarTelaInicial("101310700800");
        click(codigoProdTelaInicialLinha1);
        click(abaProdutosOpcionais);
        click(codigoProdutoOpcionalLinha1);
        click(botaoExcluir);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Produto Opcional equivalente ao Produto Principal não pode ser excluído!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela após clicar para excluir um produto que é equivalente ao produto principal");
        click(botaoOk);
        tempo();
        click(botaoVoltar);
        tempo();
        click(botaoVoltar);
    }

    public void campoObrigatorioAddProdPrincipal() {
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String produto = getText(mensagemObrigatorioProdPrinc);
        String mensagem = "Campo obrigatório";
        Assert.assertEquals(produto, mensagem, "Verificar mensagem de campo obrigatório no campo produto para adicionar um produto principal");
        tempo();
        click(botaoCancelar);
    }

    public void campoObrigatorioAddProdOpcional() {
        preencherCampoProcurarTelaInicial("101110200700");
        click(codigoProdTelaInicialLinha1);
        click(abaProdutosOpcionais);
        click(botaoAdicionar);
        tempo();
        click(botaoSalvar);

        String produto = getText(mensagemObrigatorioProdOpcional);
        String mensagem = "Campo obrigatório";
        Assert.assertEquals(produto, mensagem, "Verificar mensagem de campo obrigatório no campo produto para adicionar um produto opcional");
        tempo();
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    public void tentarAdicionarProdutoOpcionalJaExistente() {
        preencherCampoProcurarTelaInicial("101160200200");
        click(codigoProdTelaInicialLinha1);
        click(abaProdutosOpcionais);
        click(botaoAdicionar);
        click(botaoCampoProdutoOpcional);
        sendKeys(campoProcurar, "101310600300");
        click(produtoSennaFolhasGridAddProd);
        click(botaoSalvar);

        String mensagem = getText(mensagemAlerta);
        String mensagemEsperada = "Produto Opcional já cadastrado!";
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela informando que o produto opcional já foi cadastrado");
        click(botaoOk);
        tempo();
        click(botaoCancelar);
        tempo();
        click(botaoVoltar);
    }

    private void preencherCampoProcurarTelaInicial(String texto) {
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        tempo();
        if (returnClassOpened(botaoAbrirOpcoesControleTelaInicial) && !returnClassOpened(botaoPesquisarFiltro)) {
            click(botaoPesquisarFiltro);
        } else if (!returnClassOpened(botaoAbrirOpcoesControleTelaInicial)){
            click(botaoAbrirOpcoesControleTelaInicial);
            click(botaoPesquisarFiltro);
        }
        clearAndSendKeys(campoProcurar, texto);
        tempo();
    }

    private boolean returnClassOpened(By locator) {
        return driver.findElement(locator).getAttribute("className").contains("opened");
    }

}
