package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.openqa.selenium.By;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class PesquisaConsumoProdutoPage extends PageBase {

    By botaoMenu = By.xpath("//div[@class='bars']");
    By campoPesquisar = By.xpath("//section[@class='zh-container-search-menu']//input[@type='text']");
    By telaPesquisaConsumoProduto = By.xpath("//span[text() = 'Pesquisa de Consumo de Produtos']");

    By campoRelatorio = By.id("REPORT_NAME");
    By relatorioPesquisaConsumoProduto = By.xpath("//div[@data-zh-id=\"99819119441926849424761\"]//div[@class=\"list-items show-select\"]//span[text() = 'Pesquisa de Consumo de Produtos']");
    By checkBoxTodasUnidades = By.xpath("//label[@for=\"zh-checkbox-ALLFILIAL\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoUnidade = By.id("NMFILIAL");
    By unidadeDepositoBC129 = By.xpath("//div[@data-zh-field-name=\"NMFILIAL\"]//span[text() = 'DEPOSITO BC 129']");

    By checkBoxTodosServicos = By.xpath("//label[@for=\"zh-checkbox-ALLSERVICO\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoServico = By.id("NMSERVICO");
    By servicoRetirada = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'RETIRADAS']");
    By servicoJanta = By.xpath("//div[@data-zh-field-name=\"NMSERVICO\"]//span[text() = 'JANTA']");

    By campoProcurar = By.xpath("//div[@class=\"floating-card-input\"]//input");
    By botaoOk = By.xpath("//section[@class=\"popup-container\"]//div[@class=\"zh-footer-right\"]");
    By botaoCampoRelatorio = By.xpath("//div[@id=\"REPORT_NAME\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoPeriodo = By.xpath("//div[@id=\"periodo\"]//span[@style=\"background-image: none; display: block;\"][2]");
    By botaoOkAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//button");
    By botaoCampoPratoInicial = By.xpath("//div[@id=\"NMPRATOINI\"]//span[@style=\"background-image: none; display: block;\"]");
    By botaoCampoPratoFinal = By.xpath("//div[@id=\"NMPRATOFIN\"]//span[@style=\"background-image: none; display: block;\"]");

    By pratoArrozTemperado = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'ARROZ TEMPEREADO']");
    By pratoFeijaoTropeiro = By.xpath("//div[@data-zh-field-name=\"NMPRATO\"]//span[text() = 'FEIJÃO TROPEIRO']");

    By campoDataInicial = By.id("periodo_START");
    By campoDataFinal = By.id("periodo_END");

    By checkBoxProduto = By.xpath("//label[@for=\"zh-checkbox-ALLPRODUTO\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By campoProduto = By.id("NMPRODUTO");
    By produtoCreosoto = By.xpath("//div[@data-zh-field-name=\"NMPRODUTO\"]//span[text() = 'CREOSOTO']");

    By campoOrdenacao = By.xpath("//div[@data-zh-id=\"9981911947055714795\"]//div[@class=\"new-select input-text form-input-margin-bottom mousetrap form-control zh-text-align-{{field.align || 'left'}} ng-pristine ng-untouched ng-valid\"]");
    By ordenacaoCodigo = By.xpath("//div[@data-zh-id=\"9981911947055714795\"]//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Código']");
    By ordenacaoAlfabetica = By.xpath("//div[@data-zh-id=\"9981911947055714795\"]//ul[@class=\"list zh-new-select-list\"]//li[text() = 'Alfabética']");

    By checkBoxTipoConsumoCardapio = By.xpath("//label[@for=\"zh-checkbox-P_CARDAPIO\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxTipoConsumoFixo = By.xpath("//label[@for=\"zh-checkbox-P_FIXO\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By checkBoxTipoConsumoPerCapita = By.xpath("//label[@for=\"zh-checkbox-P_PERCAPITA\"]//div[@class=\"zh-box mousetrap zh-ripple-effect\"]");
    By inputTipoConsumoCardapio = By.id("zh-checkbox-P_CARDAPIO");
    By inputTipoConsumoFixo = By.id("zh-checkbox-P_FIXO");
    By inputTipoConsumoPerCapita = By.id("zh-checkbox-P_PERCAPITA");

    By botaoRelatorio = By.xpath("//div[@class='zh-footer-right']");
    By tipoPdf = By.xpath("//label[@for='radio-QR2TYPE-PDF']//div[@class='zh-inner-circle']");
    By botaoConfirmar = By.xpath("//section[@id='popup']//div[@class='zh-footer-right']//span[text() = 'Confirmar']");

    By mensagemAlerta = By.xpath("//section[@class=\"zh-container-alert\"]//div[@class=\"zh-alert-scroll\"]/p");
    By mensagemObrigatorioRelatorio = By.xpath("//div[@data-zh-id=\"99819119441926849424761\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioUnidade = By.xpath("//div[@data-zh-id=\"99819119415100644554768\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioServico = By.xpath("//div[@data-zh-id=\"9981911946960738204775\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioPeriodo = By.xpath("//div[@data-zh-id=\"99819119440934469704774\"]//div[@class=\"zh-validation\"]/span");
    By mensagemObrigatorioProduto = By.xpath("//div[@data-zh-id=\"9981911948821581274781\"]//div[@class=\"zh-validation\"]/span");


    public void acessarTela() {
        tempoParaAguardarTelaInicial();
        waitForElement(botaoMenu);
        click(botaoMenu);
        sendKeys(campoPesquisar, "Pesquisa de Consumo de Produtos");
        click(telaPesquisaConsumoProduto);
    }

    public void selecionarRelatorio() {
        tempo();
        tempo();
        clicarCampoSelecionarValor(campoRelatorio, relatorioPesquisaConsumoProduto);
    }

    public void selecionarUnidade() {
        tempo();
        click(campoUnidade);
        click(unidadeDepositoBC129);
        click(botaoOk);
    }

    public void selecionarServicos() {
        click(checkBoxTodosServicos);
        click(campoServico);
        click(servicoRetirada);
        click(servicoJanta);
        click(botaoOk);
    }

    public void preencherDatas(String dataInicial, String dataFinal) {
        super.preencherDatas(campoDataInicial, campoDataFinal, dataInicial, dataFinal);
    }

    public void selecionarProduto() {
        click(campoProduto);
        click(produtoCreosoto);
        click(botaoOk);
    }

    public void selecionarOrdenacao(String ordenacao) {
        if (ordenacao.equals("Código")) {
            clicarCampoSelecionarValor(campoOrdenacao, ordenacaoCodigo);
        } else if (ordenacao.equals("Alfabética")) {
            clicarCampoSelecionarValor(campoOrdenacao, ordenacaoAlfabetica);
        }
    }

    public void selecionarPratos() {
        click(botaoCampoPratoInicial);
        sendKeys(campoProcurar, "ARROZ TEMPEREADO");
        click(pratoArrozTemperado);
        tempo();
        click(botaoCampoPratoFinal);
        sendKeys(campoProcurar, "FEIJÃO TROPEIRO");
        click(pratoFeijaoTropeiro);
    }

    public void camposObrigatorios() {
        tempo();
        click(botaoCampoRelatorio);
        click(checkBoxTodosServicos);
        click(botaoCampoPeriodo);
        click(botaoRelatorio);

        String relatorio = getText(mensagemObrigatorioRelatorio);
        String unidade = getText(mensagemObrigatorioUnidade);
        String servico = getText(mensagemObrigatorioServico);
        String periodo = getText(mensagemObrigatorioPeriodo);
        String produto = getText(mensagemObrigatorioProduto);

        String mensagemEsperada = "Campo obrigatório";
        Assert.assertEquals(relatorio, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'relatório'");
        Assert.assertEquals(unidade, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'unidade'");
        Assert.assertEquals(servico, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'serviço'");
        Assert.assertEquals(periodo, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'período'");
        Assert.assertEquals(produto, mensagemEsperada, "Verificar mensagem de campo obrigatório no campo 'produto'");
    }

    public void obrigatorioTipoConsumo() {
        click(checkBoxTodasUnidades);
        click(checkBoxProduto);
        click(checkBoxTipoConsumoCardapio);
        click(checkBoxTipoConsumoFixo);
        click(checkBoxTipoConsumoPerCapita);
        click(botaoRelatorio);

        String mensagem = "Selecione 1 ou mais Tipos de Consumo";
        String mensagemEsperada = getText(mensagemAlerta);
        Assert.assertEquals(mensagem, mensagemEsperada, "Verificar mensagem exibida na tela ao tentar gerar um relatório sem ao menos 1 tipo de coonsumo selecionado");
        click(botaoOkAlerta);
    }

    public void deixarTodosSelecionado() {
        tempo();
        click(checkBoxTodasUnidades);
        click(checkBoxProduto);
    }

    public void tipoConsumo(String tipoConsumo) {
        tempo();
        if (returnIfElementIsSelected(inputTipoConsumoCardapio)) click(checkBoxTipoConsumoCardapio);
        if (returnIfElementIsSelected(inputTipoConsumoFixo)) click(checkBoxTipoConsumoFixo);
        if (returnIfElementIsSelected(inputTipoConsumoPerCapita)) click(checkBoxTipoConsumoPerCapita);

        switch (tipoConsumo) {
            case "Cardápio":
                click(checkBoxTipoConsumoCardapio);
                break;
            case "Fixo":
                click(checkBoxTipoConsumoFixo);
                break;
            case "Per Capita":
                click(checkBoxTipoConsumoPerCapita);
                break;
        }
    }

    public void geraRelatorio() {
        super.geraRelatorio(botaoRelatorio, tipoPdf, botaoConfirmar);
        fecharGuiaDoRelatorio();
    }

    private void fecharGuiaDoRelatorio() {
        tempo();
        tempo();
        tempo();
        tempo();
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        driver.close();
        driver.switchTo().window(winHandleBefore);
    }

}