package com.javaseleniumtemplate.pages;

import com.javaseleniumtemplate.bases.PageBase;
import org.jetbrains.annotations.NotNull;
import org.openqa.selenium.By;
import org.openqa.selenium.WebDriver;
import org.openqa.selenium.interactions.Actions;
import org.testng.Assert;

import java.util.ArrayList;
import java.util.List;

public class PrevisaoDeConsumoPage extends PageBase {
    By clicaMenu = By.xpath("//*[@type = 'button']");
    By usernameLoginInfoTextArea = By.xpath("//*[@class = 'navbar-brand zh-header-title has-header-info']");
    By clicaPlanejamento = By.xpath("//*[@class = 'menu-link']//*[contains(text(),'Planejamento')]");
    By clicaConsumo = By.xpath("//span[text() = 'Consumo']");
    By acessaPrevisaoDeConsumo = By.xpath("//span[text() = 'Cálculo da Previsão de Consumo']");
    By confirmaAcessoTela = By.xpath("//div[text() = 'Cálculo da Previsão de Consumo']");


    //Ações campo relatório
    By limpaFiltroRelatorio = By.xpath("//div[@id = 'REPORT_NAME']//span[@zh-icon= 'no-border close-x']");
    By abreFiltroRelatorio = By.xpath("//div[@id = 'REPORT_NAME']//span[@zh-icon= 'no-border search']");
    By relPrevisaoConsumoTotalPeriodo = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Total do Período)']");
    By relPrevisaoConsumoTotalPeriodoCusto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Total do Período com Custo)']");
    By relPrevisaoConsumoDataProduto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Data por Produto)']");
    By relPrevisaoConsumoDataPorProdutoComCusto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Data por Produto com Custo)']");
    By relPrevisaoConsumoProdutoPorData = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Produto por Data)']");
    By relPrevisaoConsumoProdutoPorDataComCusto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Produto por Data com Custo)']");
    By relPrevisaoConsumoConsolidado = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo - Consolidado']");
    By relPrevisaoConsumoConsolidadoParticularidade = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo - Consolidado - Particularidades']");
    By relPrevisaoConsumoPorPratoComCusto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (por Prato / com Custo)']");
    By relPrevisaoConsumoUnidadePorProduto = By.xpath("//section[@data-ng-if='popupOpen']//div[@class = 'container']//span[text() = 'Previsão de Consumo (Unidade por Produto)']");

    //Data relatório
    By limpaDataPrevisao = By.xpath("//div[@id = 'INTERVAL']//span[@zh-icon= 'no-border close-x']");
    By campoDataPrevisao = By.xpath("//div[@id = 'INTERVAL']");
    By btnAlteraPeriodo = By.xpath("//div[@class = 'arrow-right zh-icon zh-icon-forward zh-icon-no-border']");
    By dtInicial = By.xpath("//div[@data-date='01/10/2023']");
    By dtFinal = By.xpath("//div[@data-date='31/10/2023']");
    By btnOkDataPrevisao = By.xpath("//*[@class= 'zh-footer-right']//span[text() = 'OK']");

    //Ações Unidade
    By lupaAgrupamentoUnidade = By.xpath("//div[@data-zh-id='2730316301672544541659']//span[@zh-icon='no-border search']");
    By campoFilial = By.xpath("//div[@id = 'NMFILIAL']");
    By lupaFiltro = By.xpath("//*[@id='popup']//span[@class = 'action-icon search-action-icon zh-icon zh-icon-search zh-icon-no-border zh-icon-color-white']");
    By insereInformacaoBusca = By.xpath("//*[@id='popup']/span/section/section/section/section/div/div[2]/div/div[1]/ul/li[2]/div/div/div/div[3]/input");
    By btnOk = By.xpath("//span[text()= 'Ok']");
    By selecionaInformacaoBusca = By.xpath("//div[@class= 'tr cell1']");
    By checkBoxTodasUnidades = By.xpath("//label[@for= 'zh-checkbox-Todos_Unidade']");
    By marcaCheckBoxTodasUnidades = By.xpath("//label[@for= 'zh-checkbox-Todos_Unidade']//div[@class = 'zh-box mousetrap zh-ripple-effect']");


    By checkBoxTodosServicos = By.xpath("//label[@for= 'zh-checkbox-Todos_Servico']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoServico = By.xpath("//div[@id = 'NMSERVICO']");


    By checkBoxDesconsideraSubGrupoProduto = By.xpath("//label[@for= 'zh-checkbox-Desconsiderar_SubProd']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By campoSubGrupoProduto = By.xpath("//div[@id = 'NMSUBGRPROD']");
    By campoProdInicial = By.xpath("//div[@id= 'NMPRODUTOINI']//span[@zh-icon='no-border search']");
    By produtoInicial = By.xpath("//div[@class = 'tr cell1']//span[text() = 'MATERIA PRIMA']");
    By campoProdFinal = By.xpath("//div[@id= 'NMPRODUTOFIN']//span[@zh-icon='no-border search']");
    By produtoFinal = By.xpath("//div[@class = 'tr cell2']//span[text() = 'MATERIA PRIMA']");
    By limpaInformacaoNivel = By.xpath("//div[@id = 'TIPONIVEL']//span[@zh-icon='no-border close-x']");
    By lupaInformacaoNivel = By.xpath("//div[@id = 'TIPONIVEL']//span[@zh-icon='no-border search']");
    By defineNivel = By.xpath("//ul[@class = 'zh-template-list']//span[text() = '1']");
    By campoAcrescimo = By.xpath("//input[@id = 'ACRESCIMO']");
    By limpaFiltroTipoCusto = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMTIPOCUSTO zh-text-align-left']//span[@zh-icon=no-border close-x']");
    By lupaFiltrTipoCusto = By.xpath("//div[@class = 'zh-select-multiple zh-select-autocomplete mousetrap zh-field-NMTIPOCUSTO zh-text-align-left']//span[@zh-icon= 'no-border search']");
    By campoArredondamento = By.xpath("//div[@data-zh-id='2730316301386053601481']//span[@class = 'current']");
    By opcaoCompras = By.xpath("//li[text() = 'Compras']");
    By opcaoRequisicao = By.xpath("//li[text() = 'Requisição']");
    By campoOrdenacao = By.xpath("//div[@data-zh-id='273031630574623884482']//span[@class = 'current']");
    By opcaoAlfabetica = By.xpath("//li[text() = 'Alfabética']");
    By checkBoxCalcularAntesDeImprimir = By.xpath("//label[@for = 'zh-checkbox-CALCPREVCONS']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxImprimirPaginaFiltro = By.xpath("//label[@for = 'zh-checkbox-IMPRIME_F']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By checkBoxImprimirServico = By.xpath("//label[@for = 'zh-checkbox-IMPRIME_S']//div[@class = 'zh-box mousetrap zh-ripple-effect']");
    By btnCalcular = By.xpath("//li[@data-zh-id='2730316307724902951725']");
    By confirmaMensagem = By.xpath("//footer[@class = 'zh-footer-alert']//span[text() = 'OK']");
    By btnRelatorio = By.xpath("//li[@data-zh-id='27303163034557916471723']//span[text() = 'Relatório']");
    By opcaoPDF = By.xpath("//label[@for = 'radio-QR2TYPE-PDF']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By opcaoExcel = By.xpath("//label[@for = 'radio-QR2TYPE-XLSX']//div[@class = 'zh-circle mousetrap zh-ripple-effect']");
    By btnConfirmar = By.xpath("//span[text() = 'Confirmar']");



    public void navegarPrevisaoDeConsumo(){
        waitForElement(clicaMenu);
        tempo();
        tempo();
        tempo();
        click(clicaMenu);
        tempo();
        click(clicaPlanejamento);
        click(clicaConsumo);
        click(acessaPrevisaoDeConsumo);
        tempo();

    }

    public void validaCampoObrigatorio(){
        waitForVisibilityOfElementLocated(confirmaAcessoTela);
        tempo();
        click(btnRelatorio);
        tempo();

    }

    public void definePeriodo(String DTINICIAL, String DTFINAL){
        click(limpaDataPrevisao);
        clickPerform(campoDataPrevisao);
        tempo();
        click(btnAlteraPeriodo);
        click(dtInicial);
        click(dtFinal);
        click(btnOkDataPrevisao);
        tempo();
    }

    public void selecionaUnidade(String CDFILIAL){
        click(campoFilial);
        tempo();
        click(insereInformacaoBusca);
        sendKeys(insereInformacaoBusca,CDFILIAL);
        tempo();
        click(selecionaInformacaoBusca);
        click(btnOk);
        tempo();
    }

    public void selecionaServico(String CDSERVFILI){
        click(checkBoxTodosServicos);
        click(campoServico);
        tempo();
        click(insereInformacaoBusca);
        sendKeys(insereInformacaoBusca,CDSERVFILI);
        tempo();
        click(selecionaInformacaoBusca);
        click(btnOk);
        tempo();
    }

    public void defineNivelProduto(){
        tempo();
        click(limpaInformacaoNivel);
        click(lupaInformacaoNivel);
        tempo();
        click(defineNivel);
        tempo();
    }

    public void nivelProdutoRelatorio(String QTDACRESCIMO){
        click(campoProdInicial);
        tempo();
        click(lupaFiltro);
        click(produtoInicial);
        click(campoProdFinal);
        tempo();
        click(lupaFiltro);
        click(produtoFinal);
        click(campoAcrescimo);
        clearAndSendKeys(campoAcrescimo,QTDACRESCIMO);
        click(checkBoxCalcularAntesDeImprimir);
        click(checkBoxImprimirPaginaFiltro);
        click(checkBoxImprimirServico);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();
    }

    public void alteraFiltroRelatorio(){
        click(checkBoxTodasUnidades);
        click(checkBoxTodosServicos);
        tempo();
        click(campoAcrescimo);
        clearAndSendKeys(campoAcrescimo,"4");
        click(campoArredondamento);
        tempo();
        click(opcaoCompras);
        tempo();
        click(campoOrdenacao);
        tempo();
        click(opcaoAlfabetica);
        tempo();
        click(checkBoxImprimirPaginaFiltro);
        click(checkBoxImprimirServico);
        click(btnCalcular);
        tempo();
        click(confirmaMensagem);
        click(btnRelatorio);
        tempo();
        click(btnConfirmar);
        tempo();
        tempo();

    }

    public void selecionarRelatorio(@NotNull String nomeRelatorio){

        switch (nomeRelatorio) {

            case "Previsão de Consumo (Total do Período)":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoTotalPeriodo);
                break;
            case "Previsão de Consumo (Total do Período com Custo)":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoTotalPeriodoCusto);
                break;
            case "Previsão de Consumo (Data por Produto)":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoDataProduto);
                break;
            case "Previsão de Consumo (Data por Produto com Custo)":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoDataPorProdutoComCusto);
                break;
            case "Previsão de Consumo (Produto por Data)":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoProdutoPorData);
                break;
            case "Previsão de Consumo (Produto por Data com Custo)":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoProdutoPorDataComCusto);
                break;
            case "Previsão de Consumo - Consolidado":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoConsolidado);
                break;
            case "Previsão de Consumo - Consolidado - Particularidades":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoConsolidadoParticularidade);
                break;
            case "Previsão de Consumo (por Prato / com Custo)":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoPorPratoComCusto);
                break;

            case "Previsão de Consumo (Unidade por Produto)":
                click(limpaFiltroRelatorio);
                click(abreFiltroRelatorio);
                click(relPrevisaoConsumoUnidadePorProduto);
                break;
        }
    }

    public void fecharAbaRelatorio(String nomeRelatorio) {
        String winHandleBefore = driver.getWindowHandle();
        List<String> aba = new ArrayList<>(driver.getWindowHandles());
        driver.switchTo().window(aba.get(1));
        driver.getCurrentUrl();
        conferirUrl(nomeRelatorio);
        driver.close();
        driver.switchTo().window(winHandleBefore);

        tempo();
        tempo();
    }

    public void conferirUrl(String nomeRelatorio){
        String urlEncontrada = getURL().substring(0,215);
        String urlEsperada = "";

        switch (nomeRelatorio) {
            case "Previsão de Consumo (Total do Período)":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00800.rptdesign&__format=pdf";
                break;
        }

        switch (nomeRelatorio) {
            case "Previsão de Consumo (Total do Período com Custo)":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00801.rptdesign&__format=pdf";
                break;
        }

        switch (nomeRelatorio) {
            case "Previsão de Consumo (Data por Produto)":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00802.rptdesign&__format=pdf";
                break;
        }

        switch (nomeRelatorio) {
            case "Previsão de Consumo (Data por Produto com Custo)":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00803.rptdesign&__format=pdf";
                break;
        }

        switch (nomeRelatorio) {
            case "Previsão de Consumo (Produto por Data)":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00804.rptdesign&__format=pdf";
                break;
        }

        switch (nomeRelatorio) {
            case "Previsão de Consumo (Produto por Data com Custo)":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00805.rptdesign&__format=pdf";
                break;
        }

        switch (nomeRelatorio) {
            case "Previsão de Consumo - Consolidado":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00806.rptdesign&__format=pdf";
                break;
        }

        switch (nomeRelatorio) {
            case "Previsão de Consumo - Consolidado - Particularidades":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00807.rptdesign&__format=pdf";
                break;
        }

        switch (nomeRelatorio) {
            case "Previsão de Consumo (por Prato / com Custo)":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00808.rptdesign&__format=pdf";
                break;

        }

        switch (nomeRelatorio) {
            case "Previsão de Consumo (Unidade por Produto)":
                urlEsperada = "https://report-teste.teknisa.cloud//birt-viewer/run?__report=%2Fvar%2Fwww%2Ftecfood%2Fequipe_teste%2Fphp7-4%2Fteknisa_teste%2Fautomacao%2Ftecfood%2Fmodules%2Fteknisa%2Fpla%2Freports%2Fpla00809.rptdesign&__format=pdf";
                break;
        }

        Assert.assertEquals(urlEncontrada,urlEsperada,"Verificando url gerada do relatório: " + nomeRelatorio);
        }


    }














