package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.MedidasProcionamentoFlows;
import com.javaseleniumtemplate.pages.MedidasProcionamentoPage;
import org.testng.annotations.Test;

public class MedidasProcionamentoTests extends TestBase {

    MedidasProcionamentoPage medidasProcionamentoPage;
    MedidasProcionamentoFlows medidasProcionamentoFlows;
    LoginFlows loginFlows;

    //acessar a tela 'Medidas de Porcionamento'
    //clicar no botão adicionar, preencher os campos código e nome, clicar em salvar
    //na tela inicial procurar por 00010
    //verificar se o código e o nome da nova medida de de porcionamento foram adicionados com sucesso
    //no filtro preencher procurar novamente por 00010
    //clicar no código da medida de porcionamento, clicar no botão excluir, verificar a mensagem exibida na tela, clicar em sim
    //verificar a mensagem de excluído com sucesso exibida no canto superior direito da tela
    //verificar se no grid da lista de medidas é informado que nenhum registro foi encontrado
    @Test
    public void adicionarExcluirMedida() {
        medidasProcionamentoPage = new MedidasProcionamentoPage();
        medidasProcionamentoFlows = new MedidasProcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        medidasProcionamentoFlows.navegateMedidasPorcionamento();
        medidasProcionamentoPage.adicionarMedida();
        medidasProcionamentoPage.excluirMedida();
    }


    //acessar a tela 'Medidas de Porcionamento'
    //no filtro da tela inicial, procurar por 00004
    //clicar no código da medida, clicar no botão editar
    //verificar se no momento da edição, o campo código está desabilitado
    //alterar o nome da medida de porcionamento, clicar em salvar
    //atualizar a tela, no filtro inicial, procurar por 00004 e verificar se o nome alterar foi salvo corretamente
    //clicar no código da medida de, clicar em editar, alterar o nome da medida, retornando para o nome que estava no início do teste
    //clicar em salvar, clicar em voltar e verificar se o nome foi salvo corretamente
    @Test
    public void editarNomeMedida() {
        medidasProcionamentoPage = new MedidasProcionamentoPage();
        medidasProcionamentoFlows = new MedidasProcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        medidasProcionamentoFlows.navegateMedidasPorcionamento();
        medidasProcionamentoPage.editarNomeMedida();
    }


    //acessar a tela 'Medidas de Porcionamento'
    //clicar no botão adicionar, preencher o campo código (com código já existente) e nome, clicar em salvar
    //verificar a mensagem exibida na tela informando que é impossível adicionar, pois o registro já existe
    //clicar em ok, clicar em cancelar
    @Test
    public void tentarAdicionarMedidaCodigoExistente() {
        medidasProcionamentoPage = new MedidasProcionamentoPage();
        medidasProcionamentoFlows = new MedidasProcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        medidasProcionamentoFlows.navegateMedidasPorcionamento();
        medidasProcionamentoPage.tentarAdicionarCodigoExistente();
    }


    //acessar a tela 'Medidas de Porcionamento'
    //clicar no botão adicionar, clicar em salvar, verificar a mensagem de campo obrigatório nos campos: código e nome
    //clicar em cancelar, clicar no código da medida de porcionamento, clicar em editar, deixar o campo nome vazio, clicar em salvar
    //verificar a mensagem de campo obrigatório no campo nome
    @Test
    public void camposObrigatorios() {
        medidasProcionamentoPage = new MedidasProcionamentoPage();
        medidasProcionamentoFlows = new MedidasProcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        medidasProcionamentoFlows.navegateMedidasPorcionamento();
        medidasProcionamentoPage.camposObrigatorios();
    }


    //acessar a tela 'Medidas de Porcionamento'
    //no filtro da tela inicial, procurar por 00003
    //clicar no código da medida de porcionamento, clicar no botão excluir, verificar a mensagem exibida na tela, clicar em não
    //clicar em voltar, verificar se o código e o nome da medida de código 00003 não foram excluídos
    @Test
    public void cancelamentoDeExclusao() {
        medidasProcionamentoPage = new MedidasProcionamentoPage();
        medidasProcionamentoFlows = new MedidasProcionamentoFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        medidasProcionamentoFlows.navegateMedidasPorcionamento();
        medidasProcionamentoPage.cancelarExclusao();
    }

}
