package com.javaseleniumtemplate.tests;

import com.javaseleniumtemplate.bases.TestBase;
import com.javaseleniumtemplate.flows.LoginFlows;
import com.javaseleniumtemplate.flows.RequisicaoGeralFlows;
import com.javaseleniumtemplate.pages.RequisicaoGeralPage;
import org.testng.annotations.Test;

import java.util.ArrayList;
import java.util.List;

public class RequisicaoGeralTests extends TestBase {

    RequisicaoGeralPage requisicaoGeralPage;
    RequisicaoGeralFlows requisicaoGeralFlows;
    LoginFlows loginFlows;

//    relatorioRequisicaoGeral = Requisição Geral
//    relatorioConsolidado = Requisição Geral - Consolidado
//    relatorioProdutoPorServicoPrato = Requisição Geral - Produto por Serviço/Prato
//    relatorioTipoPrato = Requisição Geral - (por Tipo de Prato)


    @Test
    public void relatorioRequisicaoGeral() {
        relatorio("Requisição Geral");
    }

    @Test
    public void relatorioConsolidado() {
        relatorio("Requisição Geral - Consolidado");
    }

    @Test
    public void relatorioProdutoPorServicoPrato() {
        relatorio("Requisição Geral - Produto por Serviço/Prato");
    }

    @Test
    public void relatorioTipoPrato() {
        relatorio("Requisição Geral - (por Tipo de Prato)");
    }



    //acessar a tela 'Requisição Geral'
    //selecionar o relatório cujo o nome é passado como parâmetro
    //preencher as datas inicial e final
    //caso o relatório passado como parâmetro seja diferente do 'Requisição Geral - (por Tipo de Prato)', será gerado o relatório com 'Todas' as unidade e 'Todos' os grupos de serviço 'Todos' os serviços selecionados
    //após fechar a guia do relatório gerado, clicar no check-box de 'Todas' as unidade, clicar no campo unidade, selecionar as unidade Deposito Jabaquara e Deposito BC 111, clicar no botão ok
    //clicar no check-box 'Todos' grupos de serviço, clicar no campo grupo de serviço, selecionar os grupos (geral, compras e entregas), clicar em ok
    //clicar no check-box 'Todos' serviços, clicar no campo serviço, selecionar os serviços (Almoço Especial, Jantar, Retiradas, Janta), clicar em ok
    //caso o relatório passado como parâmetro seja o 'Requisição Geral - (por Tipo de Prato)', irá clicar no check-box 'Todos' tipo de prato, clicar no campo tipo de prato, selecionar os tipos (arroz, guarnição, principal e sobremesa), clicar em ok
    //clicar no botão do campo produto inicial, pesquisar pelo código do produto CREOSOTO e selecionar o mesmo, clicar no botão do campo produto final, pesquisar pelo código do produto CARVÃO ATIVO e selecionar o mesmo
    //clicar no botão relatório, clicar em pdf, clicar em confirmar e fechar a guia do relatório gerado
    public void relatorio(String nomeRelatorio) {
        requisicaoGeralPage = new RequisicaoGeralPage();
        requisicaoGeralFlows = new RequisicaoGeralFlows();
        loginFlows = new LoginFlows();

        String dataInicial = "01/02/2024";
        String dataFinal = "31/03/2024";

        loginFlows.efetuarLogin();
        requisicaoGeralFlows.navegateTelaRequisicaoGeral();
        requisicaoGeralPage.selecionarRelatorio(nomeRelatorio);
        requisicaoGeralPage.preencherDatas(dataInicial, dataFinal);
        if (!nomeRelatorio.equals("Requisição Geral - (por Tipo de Prato)")) requisicaoGeralPage.gerarRelatorio();
        requisicaoGeralPage.selecionarUnidades();
        requisicaoGeralPage.selecionarGrupoServico();
        requisicaoGeralPage.selecionarServicos();
        if (nomeRelatorio.equals("Requisição Geral - (por Tipo de Prato)")) requisicaoGeralPage.selecionarTipoPrato();
        requisicaoGeralPage.selecionarProdutos();
        requisicaoGeralPage.gerarRelatorio();
    }



    //acessar a tela 'Requisição Geral'
    //verificar se os check-box das opções de tipo de consumo (cardápio, fixo e per capita), estão selecionados
    //clicar no check-box das opções de tipo de consumo (cardápio, fixo e per capita) e verificar se as mesmas passam a não estar mais selecionadas
    //clicar no botão relatório e verificar a mensagem exibida na tela informando que ao menos 1 tipo de consumo deve ser selecionado, clicar no botão ok
    @Test
    public void validarTipoConsumo() {
        requisicaoGeralPage = new RequisicaoGeralPage();
        requisicaoGeralFlows = new RequisicaoGeralFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoGeralFlows.navegateTelaRequisicaoGeral();
        requisicaoGeralPage.validarTipoConsumo();
    }


    //acessar a tela 'Requisição Geral'
    //verificar se o check-box da opção 'Imprimir Linhas em Branco' está não está selecionado, e consequentemente o campo 'Nr. Linhas' está desabilitado
    //clicar no check-box da opção 'Imprimir Linhas em Branco', verificar se o mesmo passa a não estar mais selecionado e consequentemente o campo 'Nr. Linhas' passa a estar habilitado
    //preencher o campo 'Nr. Linhas' com o valor 15 e verificar se o valor foi inserido corretamente
    @Test
    public void campoNumeroLinhas() {
        requisicaoGeralPage = new RequisicaoGeralPage();
        requisicaoGeralFlows = new RequisicaoGeralFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoGeralFlows.navegateTelaRequisicaoGeral();
        requisicaoGeralPage.validarCampoNumeroDeLinhas();
    }


    //acessar a tela 'Requisição Geral'
    //verificar se o check-box da opção 'Calcula Requisição Geral' está selecionado, e consequentemente o campo 'Percentual de Acréscimo' está habilitado
    //preencher o campo 'Percentual de Acréscimo' com o valor 3,75 e verificar se o campo ficou preenchido com o valor 3,750
    //clicar no check-box da opção 'Calcula Requisição Geral', verificar se o mesmo passa não estar mais selecionado e consequentemente o campo 'Percentual de Acréscimo' passa a estar desabilitado
    @Test
    public void campoPercentualAcressimo() {
        requisicaoGeralPage = new RequisicaoGeralPage();
        requisicaoGeralFlows = new RequisicaoGeralFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoGeralFlows.navegateTelaRequisicaoGeral();
        requisicaoGeralPage.validarCampoPercentualAcrescimo();
    }


    //acessar a tela 'Requisição Geral'
    //rolar a página, clicar na ordenação 'Alfabética pelo Nível', clicar no campo nível e verificar a quantidade de opções de níveis apresentados
    //selecionar a quarta opção e verificar se o campo nível ficou preenchido com o valor 'Nível 3'
    @Test
    public void niveis() {
        requisicaoGeralPage = new RequisicaoGeralPage();
        requisicaoGeralFlows = new RequisicaoGeralFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoGeralFlows.navegateTelaRequisicaoGeral();
        requisicaoGeralPage.verificarNiveis();
    }


    //acessar a tela 'Requisição Geral'
    //clicar no campo relatório e selecionar o relatório 'Requisição Geral - (por Tipo de Prato)'
    //clicar no botão relatório, tipo pdf, confirmar
    //verificar a mensagem exibida na tela informando que 'Existe(m) serviço(s) que não utiliza(m) requisição/retirada por prato.' clicar em ok
    @Test
    public void notificacaoRelatorioTipoPrato() {
        requisicaoGeralPage = new RequisicaoGeralPage();
        requisicaoGeralFlows = new RequisicaoGeralFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoGeralFlows.navegateTelaRequisicaoGeral();
        requisicaoGeralPage.selecionarRelatorio("Requisição Geral - (por Tipo de Prato)");
        requisicaoGeralPage.mensagemServicoNaoUtilizaRequisicaoRetirada();
    }


    //acessar a tela 'Requisição Geral'
    //é gerada uma lista com o nome de todos os relatórios da tela
    //por meio de um foreache serão selecionado um relatório da lista por vez, será verificado se o campo 'Tipo de Prato' está habilitado ou não
    //caso o relatório selecionado seja o 'Requisição Geral - (por Tipo de Prato)' o campo 'Tipo de Prato' deve estar habilitado, nos demais relatório este campo deve estar desabilitado
    //será verificado também se as opções (Quebra de Página, Imprimir Linhas em Branco, Arredonda Qtde. dos Produtos, Calcula Requisição Geral) estão habilitadas ou não
    //caso o relatório selecionado seja o 'Requisição Geral' a opção Quebra de Página deve estar habilitado, para os demais relatório, está opção deve estar desabilitadas
    //as demais opções (Imprimir Linhas em Branco, Arredonda Qtde. dos Produtos, Calcula Requisição Geral) devem estar habilitadas para o 4 relatório da tela
    @Test
    public void camposHabilitadosPelosRelatorios() {
        requisicaoGeralPage = new RequisicaoGeralPage();
        requisicaoGeralFlows = new RequisicaoGeralFlows();
        loginFlows = new LoginFlows();

        List<String> relatorios = new ArrayList<>();
        relatorios.add("Requisição Geral");
        relatorios.add("Requisição Geral - Consolidado");
        relatorios.add("Requisição Geral - Produto por Serviço/Prato");
        relatorios.add("Requisição Geral - (por Tipo de Prato)");

        loginFlows.efetuarLogin();
        requisicaoGeralFlows.navegateTelaRequisicaoGeral();

        for (String rel : relatorios) {
            requisicaoGeralPage.selecionarRelatorio(rel);
            requisicaoGeralPage.verificarCampoTipoPratoHabilitado(rel);
            requisicaoGeralPage.verificarOpcoesDeExibicaoHabilitadosPelosRelatorios(rel);
        }

    }


    //acessar a tela 'Requisição Geral'
    //clicar no botão do campo relatório, clicar no check-box 'Todas' unidades, clicar no botão do campo período, clicar no check-box 'Todos' grupo de serviço, clicar no check-box 'Todos' serviços
    //clicar no botão relatório, verificar a mensagem de "Campo obrigatório" nos campos: relatório, unidade, período, grupo de serviço e serviço
    //recarregar a página, selecionar o relatório 'Requisição Geral - (por Tipo de Prato)', para habilitar o campo tipo de prato
    //clicar no check-box 'Todos' tipo de prato, clicar no botão relatório, verificar a mensagem de 'Campo obrigatório' no campo tipo de prato
    @Test
    public void camposObrigatorios() {
        requisicaoGeralPage = new RequisicaoGeralPage();
        requisicaoGeralFlows = new RequisicaoGeralFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoGeralFlows.navegateTelaRequisicaoGeral();
        requisicaoGeralPage.camposObrigatorios();
    }



    //acessar a tela 'Requisição Geral'
    //verificar se os check-box das opções (Quebra de Página e Calcula Requisição Geral) estão selecionados
    //verificar se os check-box das opções (Imprimir Linhas em Branco e Arredonda Qtde. dos Produtos) não estão selecionados
    //clicar no check-box das 4 opções e verificar se as opções (Quebra de Página e Calcula Requisição Geral) passam a não estão mais selecionados
    //verificar se os check-box das opções (Imprimir Linhas em Branco e Arredonda Qtde. dos Produtos) passam a estar selecionados
    @Test
    public void checkBoxsOpcoesDeExibicaoDosRelatorios() {
        requisicaoGeralPage = new RequisicaoGeralPage();
        requisicaoGeralFlows = new RequisicaoGeralFlows();
        loginFlows = new LoginFlows();

        loginFlows.efetuarLogin();
        requisicaoGeralFlows.navegateTelaRequisicaoGeral();
        requisicaoGeralPage.verificarCheckBoxDasOpcoesDeExibicaoDosRelatorios();
    }


}
